;	================================================================================

;	The function reads a file and returns 1 if the reading is OK. If the reading has failed, it return 0.
;	If the reading detected the end of file, it returns -1

;	Args :
;			__hFile				HANDLE	Handle of the file to read.
;			__lpBuffer			LPBYTE	In this buffer will be stored the reading result.
;			__dwBufferLength	DWORD	Size of the reading buffer in bytes.

File_Read					PROC	__hFile:HANDLE,__lpBuffer:LPBYTE,__dwBufferLength:DWord
							LOCAL	_dwNumberOfBytesRead:DWord

							lea		eax,_dwNumberOfBytesRead

							push	NULL
							push	eax
							push	__dwBufferLength
							push	__lpBuffer
							push	__hFile
							call	ReadFile	

							test	eax,eax
							jz		@Exit

								mov		eax,_dwNumberOfBytesRead

								test	eax,eax
								jz		@Eof

									sub		eax,__dwBufferLength
									jnz		@Error

										mov		eax,1
										jmp		@Exit

@Eof :

								mov		eax,-1
								jmp		@Exit

@Error :

							xor		eax,eax

@Exit :

							ret
File_Read					ENDP

;	================================================================================
